object Form1: TForm1
  Left = 316
  Top = 256
  AutoSize = True
  Caption = 'Chi=Squared testing of Random Number Generators.'
  ClientHeight = 715
  ClientWidth = 1148
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -14
  Font.Name = 'Arial'
  Font.Style = []
  OldCreateOrder = False
  Position = poScreenCenter
  PixelsPerInch = 120
  TextHeight = 16
  object StaticText1: TStaticText
    Left = 0
    Top = 692
    Width = 1148
    Height = 23
    Cursor = crHandPoint
    Align = alBottom
    Alignment = taCenter
    Caption = 'Copyright '#169' 2013, Gary Darby,  www.DelphiForFun.org'
    Font.Charset = DEFAULT_CHARSET
    Font.Color = clBlue
    Font.Height = -17
    Font.Name = 'Arial'
    Font.Style = [fsBold, fsUnderline]
    ParentFont = False
    TabOrder = 0
    OnClick = StaticText1Click
  end
  object Panel1: TPanel
    Left = 0
    Top = 0
    Width = 1148
    Height = 692
    Align = alClient
    Font.Charset = DEFAULT_CHARSET
    Font.Color = clWindowText
    Font.Height = -14
    Font.Name = 'Arial'
    Font.Style = []
    ParentFont = False
    TabOrder = 1
    object Memo1: TMemo
      Left = 1
      Top = 1
      Width = 553
      Height = 690
      Align = alLeft
      Font.Charset = DEFAULT_CHARSET
      Font.Color = clWindowText
      Font.Height = -17
      Font.Name = 'Courier'
      Font.Style = []
      ParentFont = False
      ScrollBars = ssVertical
      TabOrder = 0
    end
    object PageControl1: TPageControl
      Left = 560
      Top = 24
      Width = 588
      Height = 649
      ActivePage = TabSheet1
      Font.Charset = DEFAULT_CHARSET
      Font.Color = clWindowText
      Font.Height = -17
      Font.Name = 'Arial'
      Font.Style = []
      ParentFont = False
      TabOrder = 1
      object TabSheet1: TTabSheet
        Caption = 'Chi_Squared Test'
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -17
        Font.Name = 'Arial'
        Font.Style = []
        ParentFont = False
        ExplicitHeight = 583
        object CHSQDemoBtn: TButton
          Left = 152
          Top = 554
          Width = 201
          Height = 25
          Caption = 'Chi-Squared 1 Demo'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -14
          Font.Name = 'Arial'
          Font.Style = []
          ParentFont = False
          TabOrder = 0
          OnClick = CHSQDemoBtnClick
        end
        object Memo4: TMemo
          Left = 12
          Top = 35
          Width = 540
          Height = 470
          Color = 14548991
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          Lines.Strings = (
            
              'This program ultiimately tests our Random Number Generators (act' +
              'ually '
            
              'Delphi'#39's for 32 bit and a local implementation for 64 bit number' +
              's) to '
            
              'determine if the numbers generated are at least uniformly distri' +
              'byted  '
            
              'across a range.  .  There are many algorithms to test randomness' +
              '; this '
            
              'program the Chi-Squared  statistic which measures the deviation ' +
              'of '
            
              'random samples from the expected distribution.   There are three' +
              ' pages '
            'presented here presented in the order I wrote them.       '
            ''
            
              'The first experiment replicates the Demo program which came with' +
              ' '
            
              'ChiSquare 1 procedure, ChisOne,  (single random variable vs. one' +
              ' of '
            'known distribution).'
            ''
            
              'The demo program was implemented to see that Chi-Squared procedu' +
              're '
            
              'was successfully converted from old  "Numerical Receipes for Pas' +
              'cal" '
            
              'code to run under Delphi.  As yet I have no idea what it does or' +
              ' whether '
            
              'the results match although "Numerical  Receipies in Pascal" book' +
              ' is on '
            'order so more information may be available soon. '
            ''
            
              'I did note that the test "fudges" degrees of freedom to match th' +
              'e '
            
              'number of bins (categories) rather than (bins - 1) which is norm' +
              'ally '
            'correct.  More later.'
            ' '
            
              'The next page replicates the results of tests performed by Donal' +
              'd Knuth '
            'many years ago.  '
            ''
            '  ')
          ParentFont = False
          TabOrder = 1
          OnChange = Memo4Change
        end
      end
      object TabSheet2: TTabSheet
        Caption = '  Knuth'#39's Chi-Squared Test  '
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -14
        Font.Name = 'Arial'
        Font.Style = []
        ImageIndex = 1
        ParentFont = False
        ExplicitHeight = 583
        object Memo3: TMemo
          Left = 3
          Top = 24
          Width = 574
          Height = 506
          Color = 14548991
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          Lines.Strings = (
            'Chapter 3 in Donald Knuth'#39's classic work "The Art of Computer'
            
              'Programming"  dediicates 170 pages to generating and testing ran' +
              'dom '
            
              'numbers.  Virtually all software Random Number Generators (RNGs)' +
              ' are '
            
              'called "Pseudo" generators because after the first number, each ' +
              'value '
            'returned is based on the last value returned.  Since there are'
            
              'only a finite number of values, eventually a returned number wil' +
              'l '
            'repeat and a new identical cycle begins.'
            ''
            
              'This suggests that one good test would be to determine if the RN' +
              'G '
            
              'generates all values within its range of values, but I have not ' +
              'found or '
            
              'figured how to conduct such a test.  Almost all tests I'#39've seen ' +
              'are statistical '
            
              'sampling tests.  The Chi-Squared is the first of many found in i' +
              'n Knuth'#39's '
            
              'chapter.  I'#39've duplicated it here to validate my implementation ' +
              'of the '
            'method. '
            ''
            'The first Chi-Squared test compares an observed distribution of '
            
              'experimental results with a theoretical distribution.  Knuth thr' +
              'ew 2 standard '
            
              'dice 144 times (says it got too boring to do more), and compares' +
              ' the '
            
              'number of occurrences of each sum to the theoretical count of su' +
              'ms '
            
              '(from 2 (1 & 1) to 12 (6 & 6)).   For 144 throws the theroretica' +
              'l distribution '
            
              'of the 11 possible sums from 2 through 12 are (4, 8, 12, 16, 20,' +
              ' 24, 20, '
            
              '16, 12,  8, 4) and the observed counts for those sums was (2, 4,' +
              ' 10, 12, '
            
              '22, 29, 21, 15,  4, 9, 6).  Chi-Square staistic is calculated as' +
              ' the sum of '
            
              'the quotient of  the squared dfferences of each (observed count ' +
              '- '
            
              'expected count)^2  divided by the expected count. In this case C' +
              'hi-'
            
              'Squared = (2-4)^2/4 + (4 -8)^2/8 + (19-12)^2/12 + .... + (6-4)^2' +
              '/4 = '
            '7.1458.'
            ''
            
              'The significance of this number is based on the degrees of freed' +
              'om '
            
              '(number of sum bins -1). Knuth has a lookup table for several de' +
              'grees of '
            
              'freedom values which allow estimatting the probability that the ' +
              'differences '
            
              'from drawing a random sample from the throretical distribution w' +
              'ill be '
            
              'greater than or equal to the observed differences.  Knuth argues' +
              ' '
            
              'convincingly that for a single test we shoud expect the probabil' +
              'ies to fall in '
            
              'the 0.25 to 0.75 range.  If the value is high there very little ' +
              'chance that the '
            
              'true distribution would produce a Chi-Sq value this high..  On t' +
              'he other '
            
              'hand if all values are close to expected, Chi-Squared is low and' +
              ' our trial '
            
              'reflect the true ditribution of sums, but it'#39's so close that it ' +
              'is likely that the '
            
              '"books were cooked" (e.g. the dice thrower could control the sum' +
              ' thrown '
            
              'and deliberately tried to match the theoretical distribution) an' +
              'd this is not a '
            
              'true random sample.  Knuth says that probability results between' +
              ' .25 and '
            
              '.75 (Chi-Sq between 6.7 and 12.6) should occur half the time and' +
              '  '
            'indicates that our dice results are probably random.'
            ''
            
              'I call this a weak test for confirming randomness tbecause Chi-S' +
              'q values '
            
              'would have to be < 3.9 or > 18.5 for us to be 95% sure that the ' +
              'dice were '
            
              'loaded after 144 throws.  Knuth'#39's .25 to .75 range will occur on' +
              'ly 50% of '
            
              'the time even if the observed sampe is from a random distributio' +
              'n.  On the '
            
              'next page, we'#39'll take advantage of the computer to generate many' +
              ' more '
            'samples and multiple trials for our Random Number Generators.'
            '')
          ParentFont = False
          ScrollBars = ssVertical
          TabOrder = 0
        end
        object KnuthBtn: TButton
          Left = 158
          Top = 552
          Width = 189
          Height = 25
          Caption = 'Calculate Knuth results'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -14
          Font.Name = 'Arial'
          Font.Style = []
          ParentFont = False
          TabOrder = 1
          OnClick = KnuthBtnClick
        end
      end
      object TabSheet3: TTabSheet
        Caption = 'My RNG Chi-Squared Tests  '
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -14
        Font.Name = 'Arial'
        Font.Style = []
        ImageIndex = 2
        ParentFont = False
        ExplicitHeight = 587
        object Label2: TLabel
          Left = 396
          Top = 503
          Width = 129
          Height = 35
          AutoSize = False
          Caption = 'Number of bins for quantile testing'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -14
          Font.Name = 'Arial'
          Font.Style = []
          ParentFont = False
          WordWrap = True
        end
        object Label3: TLabel
          Left = 23
          Top = 432
          Width = 129
          Height = 57
          AutoSize = False
          Caption = 'Number of trials (Detail displayed for 1st 10 trials)'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          ParentFont = False
          WordWrap = True
        end
        object Label4: TLabel
          Left = 23
          Top = 506
          Width = 129
          Height = 39
          AutoSize = False
          Caption = 'Number of samples per trial'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          ParentFont = False
          WordWrap = True
        end
        object Memo2: TMemo
          Left = 12
          Top = 19
          Width = 541
          Height = 358
          Color = 14548991
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          Lines.Strings = (
            
              'This experiment was the motivation for entire program while look' +
              'ing'
            
              'for a way to validate the "randomness" of the 64 bit randon numb' +
              'er '
            'generator recently (November 2013) implemented in our Mathslib '
            
              'unit.  On-line searches for ways to verify the quality of an RNG' +
              ' led '
            'me to Knuth which led me to the Chi-Squared test.'
            ''
            
              'The Chi-Squared test is not a very strong indicator of randomnes' +
              's.'
            
              'For a given set of numbers placed into bins based on their value' +
              ', the '
            
              'statistic is applied  to differences between the observed freque' +
              'ncy '
            'and the expected frequency for the assumed distribution of the '
            
              'population.  Random numbers have a theoretical uniform distribut' +
              'ion '
            
              'so each bin should have the same value. One test is to count the' +
              ' '
            
              'number of occurrences of each of the digits 0 through 9.  Anothe' +
              'r '
            'partitioning is implemented in the "Quantile" button below which'
            
              'divides the total range of random numbers into a specified numbe' +
              'r'
            'of bins.'
            ''
            
              'Any individual trial can produce a wide range of Chi-Squared val' +
              'ues'
            
              'which should be centered about the 50% critical value.  Averagin' +
              'g '
            
              'many trials should produce a mean Chi-Squared value near this 50' +
              '% '
            
              'critical value.  I implemented a "Number of Trials" field to tes' +
              't this and '
            
              'in fact it seems that running 1,000 trials with 1,000 samples pe' +
              'r trial '
            
              '(1 million samples in total) usually produces results in the 49%' +
              ' to 51% '
            
              'range. - good evidence that our random number are at least unifo' +
              'rmly '
            'distributed.  Good enough for now.'
            '  '
            ''
            ''
            '')
          ParentFont = False
          ScrollBars = ssVertical
          TabOrder = 0
        end
        object DecilesBtn: TButton
          Left = 362
          Top = 538
          Width = 209
          Height = 42
          BiDiMode = bdLeftToRight
          Caption = 'Quantile distribution of values across entire range'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -14
          Font.Name = 'Arial'
          Font.Style = []
          ParentBiDiMode = False
          ParentFont = False
          TabOrder = 1
          WordWrap = True
          OnClick = DecilesBtnClick
        end
        object DigitsBtn: TButton
          Left = 362
          Top = 401
          Width = 209
          Height = 73
          Caption = 'Distribution of digits for single digit random numbers'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -14
          Font.Name = 'Arial'
          Font.Style = []
          ParentFont = False
          TabOrder = 2
          WordWrap = True
          OnClick = DigitsBtnClick
        end
        object QuantilesEdt: TSpinEdit
          Left = 531
          Top = 503
          Width = 41
          Height = 29
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          MaxValue = 100
          MinValue = 2
          ParentFont = False
          TabOrder = 3
          Value = 10
        end
        object TrialsEdt: TSpinEdit
          Left = 158
          Top = 429
          Width = 62
          Height = 29
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          MaxValue = 1000
          MinValue = 1
          ParentFont = False
          TabOrder = 4
          Value = 10
        end
        object SamplesEdt: TSpinEdit
          Left = 158
          Top = 503
          Width = 86
          Height = 29
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          MaxValue = 100000
          MinValue = 2
          ParentFont = False
          TabOrder = 5
          Value = 10000
        end
      end
    end
  end
end
